<!---
*
* Copyright (C) 2005-2008 Razuna Ltd.
*
* This file is part of Razuna - Enterprise Digital Asset Management.
*
* Razuna is free software: you can redistribute it and/or modify
* it under the terms of the GNU Affero Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Razuna is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Affero Public License for more details.
*
* You should have received a copy of the GNU Affero Public License
* along with Razuna. If not, see <http://www.gnu.org/licenses/>.
*
* You may restribute this Program with a special exception to the terms
* and conditions of version 3.0 of the AGPL as described in Razuna's
* FLOSS exception. You should have received a copy of the FLOSS exception
* along with Razuna. If not, see <http://www.razuna.com/licenses/>.
*
--->
<cfcomponent output="false">
	
	<!--- Setup the DB if DB is not here --->
	<cffunction name="setup" access="public" output="false">
		<cfargument name="thestruct" type="Struct">
		<!---  --->
		<!--- START: CREATE TABLES --->
		<!---  --->
		<!--- Sequences --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE CATEGORIES_SEQ  START WITH 40  MAXVALUE 99999999999999999999999999  MINVALUE 0  CYCLE  NOCACHE  NOORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE COLLECTION_SEQ  START WITH 1  MAXVALUE 999999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  NOORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE CONTENT_ID_SEQ  START WITH 1  MAXVALUE 99999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  NOORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE CT_USERS_REMOTEUSERS_SEQ  MINVALUE 1 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 ORDER  NOCYCLE
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE CTUAG_SEQ  START WITH 38  MAXVALUE 999999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  ORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE CTUG_SEQ  START WITH 20  MAXVALUE 999999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  ORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE CTUH_SEQ  START WITH 24  MAXVALUE 999999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  ORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE FILE_SEQ  START WITH 207  MAXVALUE 999999999999999999999999999  MINVALUE 0  CYCLE  NOCACHE  ORDER
		</cfquery>
		<!--- <cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE FLEX_SEQ  START WITH 11  MAXVALUE 9999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  NOORDER
		</cfquery> --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE FOLDER_SEQ  START WITH 141  MAXVALUE 999999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  ORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE GROUPSADMIN_SEQ  START WITH 18  MAXVALUE 999999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  ORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE GROUPS_SEQ  START WITH 13  MAXVALUE 999999999999999999999999999  MINVALUE 0  CYCLE  NOCACHE  ORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE HOSTID_SEQ  START WITH 7  MAXVALUE 999999999999999999999999999  MINVALUE 1  NOCYCLE  NOCACHE  ORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE IMG_SEQ  START WITH 1  MAXVALUE 999999999999999999999999999  MINVALUE 1  NOCYCLE  NOCACHE  ORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE KEYWORDS_SEQ  START WITH 1  MAXVALUE 999999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  NOORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE LOG_SEQ  START WITH 1970  MAXVALUE 999999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  NOORDER
		</cfquery>
		<!--- <cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE MENUESID_SEQ  START WITH 122  MAXVALUE 9999999999999999999999999999  MINVALUE 0  CYCLE  CACHE 20  NOORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE NEWS_SEQ  START WITH 1  MAXVALUE 999999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  NOORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE PAGEID_SEQ  START WITH 122  MAXVALUE 9999999999999999999999999999  MINVALUE 1  CYCLE  CACHE 20  NOORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE PAGEOR_SEQ  START WITH 1  MAXVALUE 999999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  NOORDER
		</cfquery> --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE PERMISSIONS_SEQ  MINVALUE 1 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 NOCACHE ORDER CYCLE
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE PUB_GRP_SEQ  START WITH 16  MAXVALUE 999999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  NOORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE PUB_SEQ  START WITH 48  MAXVALUE 999999999999999999999999999  MINVALUE 0  CYCLE  NOCACHE  ORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE SCHEDULE_SEQ  MINVALUE 1 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 NOCACHE ORDER CYCLE
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE SCHED_LOG_SEQ  MINVALUE 1 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 NOCACHE ORDER CYCLE
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE USERLOGIN_SEQ  START WITH 306  MAXVALUE 999999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  ORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE USERS_LISTS_SEQ  START WITH 5  MAXVALUE 99999999999999999999999999  MINVALUE 0  CYCLE  NOCACHE  NOORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE USERS_SEQ  START WITH 41  MAXVALUE 999999999999999999999999999  MINVALUE 1  NOCYCLE  NOCACHE  ORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE USER_SHIP_SEQ  START WITH 5  MAXVALUE 9999999999999999999999999  MINVALUE 1  CYCLE  NOCACHE  NOORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE VALUELIST_SEQ  START WITH 10  MAXVALUE 999999999999999999999999999  MINVALUE 0  CYCLE  NOCACHE  NOORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE CUSTOMFIELD_SEQ  START WITH 1  MAXVALUE 999999999999999999999999999  MINVALUE 0  CYCLE  NOCACHE  NOORDER
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE SEQUENCE TEXT_SEQ  START WITH 1  MAXVALUE 999999999999999999999999999  MINVALUE 0  CYCLE  NOCACHE  NOORDER
		</cfquery>
		<!--- Modules --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE MODULES 
		(
			MOD_ID 			NUMBER NOT NULL ENABLE, 
			MOD_NAME 		VARCHAR2(50 CHAR) NOT NULL ENABLE, 
			MOD_SHORT 		VARCHAR2(3 CHAR) NOT NULL ENABLE, 
			MOD_HOST_ID 	NUMBER DEFAULT NULL, 
		CONSTRAINT MODULES_PK PRIMARY KEY (MOD_ID), 
		CONSTRAINT MODULES_UK1 UNIQUE (MOD_NAME, MOD_SHORT, MOD_HOST_ID)
		)
		</cfquery>
		<!--- Permissions --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE PERMISSIONS 
		(
			PER_ID 			NUMBER NOT NULL ENABLE, 
			PER_KEY  		VARCHAR2(50 CHAR) NOT NULL ENABLE, 
			PER_HOST_ID 	NUMBER DEFAULT NULL, 
			PER_ACTIVE 		NUMBER DEFAULT 1 NOT NULL ENABLE, 
			PER_MOD_ID 		NUMBER NOT NULL ENABLE,
			PER_LEVEL		VARCHAR2(10 CHAR),
			CONSTRAINT PERMISSIONS_PK PRIMARY KEY (PER_ID), 
			CONSTRAINT PERMISSIONS_FK_MODULES FOREIGN KEY (PER_MOD_ID)
			REFERENCES MODULES (MOD_ID) ENABLE
		)
		</cfquery>
		<!--- Groups --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE GROUPS
		(	GRP_ID 				NUMBER NOT NULL ENABLE, 
			GRP_NAME 			VARCHAR2(50 CHAR), 
			GRP_HOST_ID 		NUMBER DEFAULT NULL, 
			GRP_MOD_ID 			NUMBER NOT NULL ENABLE, 
			GRP_TRANSLATION_KEY VARCHAR2(50 CHAR), 
		CONSTRAINT GROUPS_PK PRIMARY KEY (GRP_ID), 
		CONSTRAINT GROUPS_UK1 UNIQUE (GRP_NAME, GRP_HOST_ID, GRP_MOD_ID), 
		CONSTRAINT GROUPS_FK_MODULES FOREIGN KEY (GRP_MOD_ID)
			REFERENCES MODULES (MOD_ID) ENABLE
		)
		</cfquery>
		<!--- Hosts --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE HOSTS 
		(
		  HOST_ID           NUMBER                      NOT NULL,
		  HOST_NAME         VARCHAR2(20 CHAR),
		  HOST_PATH         VARCHAR2(50 CHAR),
		  HOST_CREATE_DATE  DATE,
		  HOST_DB_PREFIX    VARCHAR2(40 CHAR),
		  HOST_LANG         NUMBER,
		  HOST_TYPE			VARCHAR2(2 CHAR) DEFAULT 'F',
		  HOST_SHARD_GROUP	VARCHAR2(10 CHAR),
		CONSTRAINT HOSTS_PK PRIMARY KEY (HOST_ID) ENABLE
		)
		</cfquery>
		<!--- Users --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE USERS 
		(
		  USER_ID              NUMBER                   NOT NULL,
		  USER_LOGIN_NAME      VARCHAR2(50 CHAR)        NOT NULL,
		  USER_EMAIL           VARCHAR2(80 CHAR)        NOT NULL,
		  USER_FIRST_NAME      VARCHAR2(80 CHAR),
		  USER_LAST_NAME       VARCHAR2(80 CHAR),
		  USER_PASS            VARCHAR2(500 CHAR)       NOT NULL,
		  USER_COMPANY         VARCHAR2(80 CHAR),
		  USER_STREET          VARCHAR2(80 CHAR),
		  USER_STREET_NR       NUMBER(6),
		  USER_STREET_2        VARCHAR2(80 CHAR),
		  USER_STREET_NR_2     NUMBER(6),
		  USER_ZIP             NUMBER(7),
		  USER_CITY            VARCHAR2(50 CHAR),
		  USER_COUNTRY         VARCHAR2(60 CHAR),
		  USER_PHONE           VARCHAR2(30 CHAR),
		  USER_PHONE_2         VARCHAR2(30 CHAR),
		  USER_MOBILE          VARCHAR2(30 CHAR),
		  USER_FAX             VARCHAR2(30 CHAR),
		  USER_CREATE_DATE     TIMESTAMP,
		  USER_CHANGE_DATE     TIMESTAMP,
		  USER_ACTIVE          VARCHAR2(2 CHAR),
		  USER_IN_ADMIN        VARCHAR2(2 CHAR),
		  USER_IN_DAM          VARCHAR2(2 CHAR),
		  USER_SALUTATION      VARCHAR2(500 CHAR),
		  USER_IN_VP		   VARCHAR2(2 CHAR) DEFAULT 'F',
		  SET2_NIRVANIX_NAME   VARCHAR2(500 CHAR),
		  SET2_NIRVANIX_PASS   VARCHAR2(500 CHAR),
		CONSTRAINT USERS_PK PRIMARY KEY (USER_ID) ENABLE
		)
		</cfquery>
		<!--- Ct_Groups_Users --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE CT_GROUPS_USERS
		(	CT_G_U_GRP_ID 		NUMBER NOT NULL ENABLE, 
			CT_G_U_USER_ID 		NUMBER NOT NULL ENABLE, 
		CONSTRAINT CT_GROUPS_USERS_UK1 UNIQUE (CT_G_U_GRP_ID, CT_G_U_USER_ID), 
		CONSTRAINT CT_GROUPS_USERS_GROUPS_FK1 FOREIGN KEY (CT_G_U_GRP_ID)
			REFERENCES GROUPS (GRP_ID) ENABLE
		)
		</cfquery>
		<!--- CT_GROUPS_PERMISSIONS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE CT_GROUPS_PERMISSIONS
		(	CT_G_P_PER_ID 		NUMBER NOT NULL ENABLE, 
			CT_G_P_GRP_ID 		NUMBER NOT NULL ENABLE, 
		CONSTRAINT CT_GROUPS_PERMISSIONS_UK1 UNIQUE (CT_G_P_PER_ID, CT_G_P_GRP_ID), 
		CONSTRAINT CT_GROUPS_PERMISSIONS_FK2 FOREIGN KEY (CT_G_P_PER_ID)
		REFERENCES PERMISSIONS (PER_ID) ENABLE, 
		CONSTRAINT CT_GROUPS_PERMISSIONS_FK1 FOREIGN KEY (CT_G_P_GRP_ID)
		REFERENCES GROUPS (GRP_ID) ENABLE
		)
		</cfquery>
		<!--- LOG_ACTIONS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE LOG_ACTIONS 
		(
		  LOG_ACT_ID    NUMBER,
		  LOG_ACT_TEXT  VARCHAR2(200 CHAR),
		CONSTRAINT LOG_ACTIONS_PK PRIMARY KEY (LOG_ACT_ID) ENABLE
		)
		</cfquery>
		<!--- CT_USERS_HOSTS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE CT_USERS_HOSTS 
		(
		  CT_U_H_USER_ID  NUMBER,
		  CT_U_H_HOST_ID  NUMBER
		)
		</cfquery>
		<!--- USERS_LOGIN --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE USERS_LOGIN 
		(
		  USER_LOGIN_ID         NUMBER                  NOT NULL,
		  USER_ID               NUMBER,
		  USER_LOGIN_DATE       DATE,
		  USER_LOGIN_TIME       DATE,
		  USER_LOGIN_PROJECT    NUMBER,
		  USER_LOGIN_SESSION    VARCHAR2(200 CHAR),
		  USER_LOGIN_DATESTAMP  DATE
		)
		</cfquery>
		<!--- WISDOM --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE WISDOM 
		(
		  WIS_ID      NUMBER,
		  WIS_TEXT    VARCHAR2(3000 CHAR),
		  WIS_AUTHOR  VARCHAR2(200 CHAR),
		  CONSTRAINT WISDOM_PK PRIMARY KEY (WIS_ID) ENABLE
		)
		</cfquery>
		<!--- USERS_COMMENTS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE USERS_COMMENTS
		(
		  USER_ID_R           NUMBER,
		  USER_COMMENT        VARCHAR2(4000 CHAR),
		  CREATE_DATE         DATE,
		  CHANGE_DATE         DATE,
		  USER_COMMENT_BY     NUMBER,
		  USER_COMMENT_TITLE  VARCHAR2(500 CHAR),
		  COMMENT_ID          NUMBER
		)
		</cfquery>
		<!--- FILE_TYPES --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE FILE_TYPES
		(
		  TYPE_ID              VARCHAR2(5 CHAR)    CONSTRAINT FILE_TYPE_PK PRIMARY KEY,
		  TYPE_TYPE            VARCHAR2(3 CHAR),
		  TYPE_MIMECONTENT     VARCHAR2(50 CHAR),
		  TYPE_MIMESUBCONTENT  VARCHAR2(50 CHAR)
		)
		</cfquery>
		<!--- CT_USERS_REMOTEUSERS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE CT_USERS_REMOTEUSERS
		(
		   	CT_U_RU_ID                NUMBER NOT NULL ENABLE, 
			CT_U_RU_USER_ID           NUMBER NOT NULL ENABLE, 
			CT_U_RU_REMOTE_URL        VARCHAR2(4000 CHAR) NOT NULL ENABLE, 
			CT_U_RU_REMOTE_USER_ID    NUMBER NOT NULL ENABLE, 
			CT_U_RU_REMOTE_USER_NAME  VARCHAR2(4000 CHAR) NOT NULL ENABLE, 
			CT_U_RU_REMOTE_USER_EMAIL VARCHAR2(4000 CHAR), 
			CT_U_RU_REMOTE_CONFIRMED  NUMBER DEFAULT 0 NOT NULL ENABLE, 
			CT_U_RU_UUID              VARCHAR2(4000 CHAR) NOT NULL ENABLE, 
			CT_U_RU_VALIDUNTIL        DATE, 
			CT_U_RU_CONFIRMED         NUMBER DEFAULT 0 NOT NULL ENABLE, 
		CONSTRAINT CT_USERS_REMOTEUSERS_PK PRIMARY KEY (CT_U_RU_ID),
		CONSTRAINT CT_USERS_REMOTEUSERS_UK1 UNIQUE (CT_U_RU_USER_ID, CT_U_RU_REMOTE_URL, CT_U_RU_REMOTE_USER_ID),
		CONSTRAINT CT_USERS_REMOTEUSERS_UK2 UNIQUE (CT_U_RU_UUID),
		CONSTRAINT CT_USERS_REMOTEUSERS_USER_FK1 FOREIGN KEY (CT_U_RU_USER_ID)
				REFERENCES USERS (USER_ID) ON DELETE CASCADE ENABLE
		)
		</cfquery>
		<!--- WEBSERVICES --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE WEBSERVICES
		(
			SESSIONTOKEN 	VARCHAR2(100 CHAR), 
			TIMEOUT 		TIMESTAMP,
			GROUPOFUSER		VARCHAR2(20 CHAR),
			USERID			NUMBER,
			CONSTRAINT WEBSERVICES_PK PRIMARY KEY (SESSIONTOKEN)
		)
		</cfquery>
		<!--- SEARCH REINDEX --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE SEARCH_REINDEX
		(
			theid			VARCHAR2(100 CHAR),
			thevalue		NUMBER,
			thehostid		NUMBER,
			datetime		TIMESTAMP
		)
		</cfquery>
		<!---  --->
		<!--- END: CREATE TABLES --->
		<!---  --->
		<!---  --->
		<!--- START: INSERT VALUES --->
		<!---  --->
		<!--- USERS --->
		<cfset thepass = hash("admin", "MD5", "UTF-8")>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO USERS
		(USER_ID, USER_LOGIN_NAME, USER_EMAIL, USER_FIRST_NAME, USER_LAST_NAME, USER_PASS, USER_ACTIVE, USER_IN_ADMIN, USER_IN_DAM)
		VALUES (1, 'admin', 'your email here', 'SystemAdmin', 'SystemAdmin', '#thepass#', 'T', 'T', 'T')
		</cfquery>
		<!--- MODULES --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO modules
		(mod_id, mod_name, mod_short, mod_host_id)
		VALUES(	1, 'razuna', 'ecp', NULL)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO modules
		(mod_id, mod_name, mod_short, mod_host_id)
		VALUES(	2, 'admin', 'adm', NULL)
		</cfquery>
		<!--- DEFAULT ADMIN GROUPS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO groups
		(grp_id, grp_name, grp_host_id, grp_mod_id)
		VALUES(	1, 'SystemAdmin', NULL, 2 )
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO groups
		(grp_id, grp_name, grp_host_id, grp_mod_id)
		VALUES(	2, 'Administrator', NULL, 2	)
		</cfquery>
		<!--- DEFAULT ADMIN CROSS TABLE --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO ct_groups_users
		(CT_G_U_GRP_ID, CT_G_U_USER_ID)
		VALUES(	1, 1)
		</cfquery>
		<!--- DEFAULT ADMIN PERMISSIONS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		Insert into PERMISSIONS (PER_ID,PER_KEY,PER_HOST_ID,PER_ACTIVE,PER_MOD_ID,PER_LEVEL) values (1,'SystemAdmin',null,1,2,null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		Insert into PERMISSIONS (PER_ID,PER_KEY,PER_HOST_ID,PER_ACTIVE,PER_MOD_ID,PER_LEVEL) values (2,'Administrator',null,1,2,null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		Insert into PERMISSIONS (PER_ID,PER_KEY,PER_HOST_ID,PER_ACTIVE,PER_MOD_ID,PER_LEVEL) values (3,'PER_USERS:N',null,1,2,null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		Insert into PERMISSIONS (PER_ID,PER_KEY,PER_HOST_ID,PER_ACTIVE,PER_MOD_ID,PER_LEVEL) values (4,'PER_USERS:R',null,1,2,null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		Insert into PERMISSIONS (PER_ID,PER_KEY,PER_HOST_ID,PER_ACTIVE,PER_MOD_ID,PER_LEVEL) values (5,'PER_USERS:W',null,1,2,null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		Insert into PERMISSIONS (PER_ID,PER_KEY,PER_HOST_ID,PER_ACTIVE,PER_MOD_ID,PER_LEVEL) values (6,'PER_GROUPS:N',null,1,2,null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		Insert into PERMISSIONS (PER_ID,PER_KEY,PER_HOST_ID,PER_ACTIVE,PER_MOD_ID,PER_LEVEL) values (7,'PER_GROUPS:R',null,1,2,null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		Insert into PERMISSIONS (PER_ID,PER_KEY,PER_HOST_ID,PER_ACTIVE,PER_MOD_ID,PER_LEVEL) values (8,'PER_GROUPS:W',null,1,2,null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		Insert into PERMISSIONS (PER_ID,PER_KEY,PER_HOST_ID,PER_ACTIVE,PER_MOD_ID,PER_LEVEL) values (9,'PER_GROUPS_ADMIN:N',null,1,2,null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		Insert into PERMISSIONS (PER_ID,PER_KEY,PER_HOST_ID,PER_ACTIVE,PER_MOD_ID,PER_LEVEL) values (10,'PER_GROUPS_ADMIN:R',null,1,2,null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		Insert into PERMISSIONS (PER_ID,PER_KEY,PER_HOST_ID,PER_ACTIVE,PER_MOD_ID,PER_LEVEL) values (11,'PER_GROUPS_ADMIN:W',null,1,2,null)
		</cfquery>
		<!--- DEFAULT ADMIN PERMISSIONS CROSS TABLE --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO	ct_groups_permissions( CT_G_P_PER_ID, CT_G_P_GRP_ID )VALUES( 1, 1 )
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO	ct_groups_permissions( CT_G_P_PER_ID, CT_G_P_GRP_ID )VALUES( 2, 1 )
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO	ct_groups_permissions( CT_G_P_PER_ID, CT_G_P_GRP_ID )VALUES( 3, 1 )
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO	ct_groups_permissions( CT_G_P_PER_ID, CT_G_P_GRP_ID )VALUES( 4, 1 )
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO	ct_groups_permissions( CT_G_P_PER_ID, CT_G_P_GRP_ID )VALUES( 5, 1 )
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO	ct_groups_permissions( CT_G_P_PER_ID, CT_G_P_GRP_ID )VALUES( 6, 1 )
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO	ct_groups_permissions( CT_G_P_PER_ID, CT_G_P_GRP_ID )VALUES( 7, 1 )
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO	ct_groups_permissions( CT_G_P_PER_ID, CT_G_P_GRP_ID )VALUES( 8, 1 )
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO	ct_groups_permissions( CT_G_P_PER_ID, CT_G_P_GRP_ID )VALUES( 9, 1 )
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO	ct_groups_permissions( CT_G_P_PER_ID, CT_G_P_GRP_ID )VALUES( 10, 1 )
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO	ct_groups_permissions( CT_G_P_PER_ID, CT_G_P_GRP_ID )VALUES( 11, 1 )
		</cfquery>
		<!--- WISDOM --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		2, 'In giving advice, seek to help, not please, your friend.', 'Solon')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		3, 'A friend is one to whom you can pour out the contents of your heart, chaff and grain alike. Knowning that the gentlest of hands will take and sift it, keep what is worth keeping, and with a breath of kindness, blow the rest away.'
		, 'Anonymous')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		4, 'The most exciting phrase to hear in science, the one that heralds new discoveries, is not "Eureka" (I found it!) but "That''s funny ..."', 'Isaac Asimov')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		5, 'Everyone should carefully observe which way his heart draws him, and then choose that way with all his strength!'
		, 'Hasidic saying')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		6, 'Mend your speech a little, lest it may mar your fortunes.', 'Shakespeare, King Lear')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#"> 
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		7, 'In preparing for battle I have always found that plans are useless, but planning is indispensable.'
		, 'Dwight D. Eisenhower')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		8, 'It''s all right to aim high if you have plenty of ammunition.', 'Hawley R. Everhart')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#"> 
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		10, 'A great civilization is not concurred from without until it has destroyed itself from within.', 'Will Durant')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		11, 'Travel far enough away, my friend, and you''ll discover something of great beauty: your self', 'Cirque du Soleil')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		1, 'There are Painters who transform the sun to a yellow spot, but there are others who with the help of their art and their intelligence, transform a yellow spot into the sun.', 'Pablo Picasso')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#"> 
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		9, 'The significant problems we have cannot be solved at the same level of thinking with which we created them.'
		, 'Albert Einstein')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		12, 'Acquaintance, n.: A person whom we know well enough to borrow from, but not well enough to lend to. '
		, 'Ambrose Bierce')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		13, 'The best investment is in the tools of one''s trade.', 'Benjamin Franklin')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#"> 
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		14, 'We all agree that your theory is crazy -- but is it crazy enough?', 'Niels Bohr')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#"> 
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		15, 'Genius without education is like silver in the mine.', 'Benjamin Franklin')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#"> 
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		16, 'Anybody can sympathise with the sufferings of a friend, but it requires a very fine nature to sympathise with a friend''s success.', 'Oscar Wilde')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		17, 'Absurdity, n.: A statement or belief manifestly incosistent with one''s own.', 'Ambrose Bierce')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#"> 
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		18, 'There''s no trick to being a humorist when you have the whole government working for you.', 'Will Rogers')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		19, 'The real question is not whether machines think but whether men do. The mystery which surrounds a thinking machine already surrounds a thinking man.', 'B.F.Skinner')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		20, 'That we must all die, we always knew; I wish I had remembered it sooner.', 'Samuel Johnson')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		21, 'The key to living well is first to will that which is necessary and then to love that which is willed.', 'Irving Yalom')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		22, 'Always tell the truth. You will gratify some people and astonish the rest.', 'Mark Twain')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		23, 'See everything. Ignore a lot. Improve a little.', 'Pope John Paul II')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		24, 'Resentment is like taking poison and hoping the other person dies.', 'St. Augustine')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		25, 'Hope is definitely not the same thing as optimism. It is not the conviction that something will turn out well, but the certainty that something makes sense, regardless of how it turns out.', 'Vaclav Havel')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		26, 'We must never be ashamed of our tears, they are rain from heaven washing the dust from our hard hearts.', 'Charles Dickens')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		27, 'Our business in life is not to succeed, but to continue to fail in good spirits.', 'Robert Louis Stevenson')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		28, 'Be who you are and say what you feel because the people who mind don''t matter and the people who matter don''t mind.', 'Theodor Geisel')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		29, 'It is well to remember that the entire universe, with one trifling exception, is composed of others.', 'John Andrew Holmes')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		30, 'Fail to honor people, they fail to honor you.', 'Lao Tzu')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		31, 'You can leave anything out, as long as you know what it is.', 'Ernest Hemingway')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		32, 'The future is here. It''s just not evenly distributed yet.', 'William Gibson')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		33, 'The future always comes too fast and in the wrong order.', 'Alvin Toffler')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		34, 'There will always be people who are ahead of the curve, and people who are behind the curve. But knowledge moves the curve.', 'Bill James')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		35, 'History is a wave that moves through time slightly faster than we do.', 'Kim Stanley Robinson')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		36, 'Inspiration is for amateurs. I just get to work.', 'Chuck Close')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		37, 'The best and most beautiful things in the world cannot be seen or even touched. They must be felt with the heart.', 'Hellen Keller')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		38, 'Small opportunities are often the beginning of great enterprises.', 'Demosthenes')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		39, 'Simplicity is the utlimate sophistication.', 'Leonardo da Vinci')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		40, 'A journey of thousand miles begins with a single step.', 'Lao tzu')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		41, 'What we think, we become.', 'Buddha')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO WISDOM ( WIS_ID, WIS_TEXT, WIS_AUTHOR ) VALUES ( 
		42, 'Great minds discuss ideas. Average minds discuss events. Small minds discuss people.', 'Eleanor Roosevelt')
		</cfquery>
		<!--- FILE TYPES --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('doc', 'doc', 'application', 'vnd.ms-word')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('docx', 'doc', 'application', 'vnd.ms-word')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('xls', 'doc', 'application', 'vnd.ms-excel')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('xlsx', 'doc', 'application', 'vnd.ms-excel')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('ppt', 'doc', 'application', 'vnd.ms-powerpoint')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('pptx', 'doc', 'application', 'vnd.ms-powerpoint')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('pdf', 'doc', 'application', 'pdf')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('txt', 'doc', 'application', 'txt')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('psd', 'img', 'application', 'photoshop')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('eps', 'img', 'application', 'eps')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('ai', 'img', 'application', 'photoshop')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('jpg', 'img', 'image', 'jpg')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('jpeg', 'img', 'image', 'jpeg')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('gif', 'img', 'image', 'gif')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('png', 'img', 'image', 'png')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('bmp', 'img', 'image', 'bmp')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('cal', 'img', null, null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('dcm', 'img', null, null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('fpx', 'img', 'image', 'vnd.fpx')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('pbm', 'img', 'image', 'pbm')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('pgm', 'img', 'image', 'x-portable-graymap')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('ppm', 'img', 'image', 'x-portable-pixmap')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('pnm', 'img', 'image', 'x-portable-anymap')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('pcx', 'img', 'image', 'pcx')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('pct', 'img', null, null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('rpx', 'img', null, null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('ras', 'img', 'image', 'ras')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('tga', 'img', 'image', 'tga')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('tif', 'img', 'image', 'tif')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('tiff', 'img', 'image', 'tiff')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('wbmp', 'img', 'image', 'vnd.wap.wbmp')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('nef', 'img', 'image', 'nef')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('swf', 'vid', 'application', 'x-shockwave-flash')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('flv', 'vid', 'application', 'x-shockwave-flash')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('mov', 'vid', 'video', 'quicktime')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('avi', 'vid', 'video', 'avi')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('3gp', 'vid', 'video', '3gpp')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('rm', 'vid', 'application', 'vnd.rn-realmedia')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('mpg', 'vid', 'video', 'mpeg')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('mp4', 'vid', 'video', 'mp4v-es')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('wmv', 'vid', 'video', 'x-ms-wmv')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('vob', 'vid', 'video', 'mpeg')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('ogv', 'vid', 'video', 'ogv')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('webm', 'vid', 'video', 'webm')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('aff', 'aud', null, null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('aft', 'aud', null, null)
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('au', 'aud', 'audio', 'basic')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('ram', 'aud', 'audio', 'x-pn-realaudio')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO FILE_TYPES VALUES ('wav', 'aud', 'audio', 'x-wav')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('mp3', 'aud', 'audio', 'mpeg')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('aiff', 'aud', 'audio', 'x-aiff')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('aif', 'aud', 'audio', 'x-aiff')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('aifc', 'aud', 'audio', 'x-aiff')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('snd', 'aud', 'audio', 'basic')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('mid', 'aud', 'audio', 'mid')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('m3u', 'aud', 'audio', 'x-mpegurl')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('rmi', 'aud', 'audio', 'mid')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('ra', 'aud', 'audio', 'x-pn-realaudio')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('flac', 'aud', 'audio', 'flac')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('ogg', 'aud', 'audio', 'ogg')
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		INSERT INTO file_types VALUES ('m4a', 'aud', 'audio', 'x-m4a')
		</cfquery>
	</cffunction>
	
	<!--- Create Host Remote --->
	<cffunction name="create_host_remote" access="remote" output="false">
		<cfargument name="dsn" type="string" required="true">
		<cfargument name="theschema" type="string" required="true">
		<cfargument name="host_db_prefix" type="string" required="true">
		<!--- Params --->
		<cfset arguments.thestruct = structnew()>
		<cfset arguments.thestruct.dsn = arguments.dsn>
		<cfset arguments.thestruct.theschema = arguments.theschema>
		<cfset arguments.thestruct.host_db_prefix = arguments.host_db_prefix>
		<!--- Create Tables --->
		<cfinvoke method="create_tables" thestruct="#arguments.thestruct#">
		<!--- CREATE THE INDEXES
		<cfinvoke method="create_indexes" thestruct="#arguments.thestruct#"> --->
	</cffunction>
	
	<!--- Create Host --->
	<cffunction name="create_host" access="public" output="false">
		<cfargument name="thestruct" type="Struct">
		<cfset arguments.thestruct.theschema = application.razuna.theschema>
		<!--- Create Tables --->
		<cfinvoke method="create_tables" thestruct="#arguments.thestruct#">
		<!--- CREATE THE INDEXES
		<cfinvoke method="create_indexes" thestruct="#arguments.thestruct#"> --->
	</cffunction>
	
	<!--- Create Tables --->
	<cffunction name="create_tables" access="public" output="false">
		<cfargument name="thestruct" type="Struct">
		
		<!--- ASSETS_TEMP --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#assets_temp 
		(
			TEMPID 			VARCHAR2(200 CHAR), 
			FILENAME 		VARCHAR2(255 CHAR), 
			EXTENSION 		VARCHAR2(10 CHAR), 
			DATE_ADD 		TIMESTAMP, 
			FOLDER_ID		NUMBER, 
			WHO				NUMBER, 
			FILENAMENOEXT	VARCHAR2(255 CHAR), 
			PATH 			CLOB, 
			MIMETYPE		VARCHAR2(255 CHAR), 
			THESIZE			NUMBER,
			GROUPID			NUMBER,
			SCHED_ACTION	NUMBER,
			SCHED_ID		NUMBER,
			FILE_ID			NUMBER,
			LINK_KIND		VARCHAR2(20 CHAR),
			HOST_ID			NUMBER
		)
		
		</cfquery>
		
		<!--- XMP --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#xmp 
		(
			id_r					NUMBER,
			asset_type				VARCHAR2(10 CHAR),
			subjectcode				VARCHAR2(200 CHAR),
			creator					VARCHAR2(200 CHAR),
			title					VARCHAR2(200 CHAR),
			authorsposition			VARCHAR2(200 CHAR),
			captionwriter			VARCHAR2(200 CHAR),
			ciadrextadr				VARCHAR2(200 CHAR),
			category				VARCHAR2(200 CHAR),
			supplementalcategories	CLOB,
			urgency					VARCHAR2(200 CHAR),
			description				CLOB,
			ciadrcity				VARCHAR2(200 CHAR),
			ciadrctry				VARCHAR2(200 CHAR),
			location				VARCHAR2(200 CHAR),
			ciadrpcode				VARCHAR2(200 CHAR),
			ciemailwork				VARCHAR2(200 CHAR),
			ciurlwork				VARCHAR2(200 CHAR),
			citelwork				VARCHAR2(200 CHAR),
			intellectualgenre		VARCHAR2(200 CHAR),
			instructions			CLOB,
			source					VARCHAR2(200 CHAR),
			usageterms				CLOB,
			copyrightstatus			CLOB,
			transmissionreference	VARCHAR2(200 CHAR),
			webstatement			CLOB,
			headline				VARCHAR2(200 CHAR),
			datecreated				VARCHAR2(200 CHAR),
			city					VARCHAR2(200 CHAR),
			ciadrregion				VARCHAR2(200 CHAR),
			country					VARCHAR2(200 CHAR),
			countrycode				VARCHAR2(200 CHAR),
			scene					VARCHAR2(200 CHAR),
			state					VARCHAR2(200 CHAR),
			credit					VARCHAR2(200 CHAR),
			rights					CLOB,
			HOST_ID					NUMBER
		)  
		
		</cfquery>
		
		<!--- CART --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#cart
		(
		  CART_ID           	VARCHAR2(200 CHAR),
		  USER_ID           	NUMBER,
		  CART_QUANTITY     	NUMBER,
		  CART_PRODUCT_ID   	NUMBER,
		  CART_CREATE_DATE  	DATE,
		  CART_CREATE_TIME  	TIMESTAMP,
		  CART_CHANGE_DATE  	DATE,
		  CART_CHANGE_TIME  	TIMESTAMP,
		  CART_FILE_TYPE    	VARCHAR2(5 CHAR),
		  cart_order_email 		varchar2(150 CHAR),
		  cart_order_message 	varchar2(2000 CHAR), 
		  cart_order_done 		varchar2(1 CHAR), 
		  cart_order_date 		timestamp,
		  cart_order_user_r 	number,
		  HOST_ID				NUMBER
		)
		
		</cfquery>
		
		<!--- FOLDERS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#folders
		(
		  FOLDER_ID             NUMBER,
		  FOLDER_NAME           VARCHAR2(200 CHAR),
		  FOLDER_LEVEL          NUMBER,
		  FOLDER_ID_R           NUMBER,
		  FOLDER_MAIN_ID_R      NUMBER,
		  FOLDER_OWNER          NUMBER,
		  FOLDER_CREATE_DATE    DATE,
		  FOLDER_CREATE_TIME    TIMESTAMP,
		  FOLDER_CHANGE_DATE    DATE,
		  FOLDER_CHANGE_TIME    TIMESTAMP,
		  FOLDER_IS_IMG_FOLDER  VARCHAR2(2 CHAR),
		  FOLDER_IMG_PUB_ID     NUMBER,
		  FOLDER_OF_USER        VARCHAR2(2 CHAR) DEFAULT NULL,
		  FOLDER_IS_COLLECTION  VARCHAR2(2 CHAR) DEFAULT NULL,
		  FOLDER_IS_VID_FOLDER  VARCHAR2(2 CHAR),
		  FOLDER_VID_PUB_ID		NUMBER,
		  FOLDER_AVAILABLE_DSC  NUMBER DEFAULT 1,
		  FOLDER_SHARED			VARCHAR2(2 CHAR) DEFAULT 'F',
		  FOLDER_NAME_SHARED	VARCHAR2(200 CHAR),
		  LINK_PATH				VARCHAR2(200 CHAR),
		  share_dl_org			varchar2(1 char) DEFAULT 'f',
     	  share_comments		varchar2(1 char) DEFAULT 'f',
		  share_upload			varchar2(1 char) DEFAULT 'f',
		  share_order			varchar2(1 char) DEFAULT 'f',
		  share_order_user		number,
		  HOST_ID				NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#FOLDERS_HOSTS_FK1 FOREIGN KEY (HOST_ID) REFERENCES HOSTS (HOST_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- FOLDERS DESC --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#folders_desc
		(
		  FOLDER_ID_R  	NUMBER,
		  LANG_ID_R    	NUMBER,
		  FOLDER_DESC  	CLOB,
		  HOST_ID		NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#FOLDERS_DESC_HOSTS_FK1 FOREIGN KEY (HOST_ID) REFERENCES HOSTS (HOST_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- FOLDERS GROUPS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#folders_groups
		(
		  FOLDER_ID_R     	NUMBER,
		  GRP_ID_R        	NUMBER,
		  GRP_PERMISSION  	VARCHAR2(2 CHAR),
		  HOST_ID			NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#FOLDERS_GROUPS_HOSTS_FK1 FOREIGN KEY (HOST_ID) REFERENCES HOSTS (HOST_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- FILES --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#files
		(
		  FILE_ID              	NUMBER,
		  FOLDER_ID_R          	NUMBER DEFAULT NULL,
		  FILE_CREATE_DATE     	DATE,
		  FILE_CREATE_TIME     	TIMESTAMP,
		  FILE_CHANGE_DATE     	DATE,
		  FILE_CHANGE_TIME     	TIMESTAMP,
		  FILE_OWNER           	NUMBER,
		  FILE_TYPE            	VARCHAR2(5 CHAR),
		  FILE_NAME            	VARCHAR2(200 CHAR),
		  FILE_EXTENSION       	VARCHAR2(10 CHAR) DEFAULT NULL,
		  FILE_NAME_NOEXT      	VARCHAR2(200 CHAR),
		  FILE_CONTENTTYPE     	VARCHAR2(100 CHAR),
		  FILE_CONTENTSUBTYPE  	VARCHAR2(100 CHAR),
		  FILE_REMARKS         	CLOB,
		  FILE_ONLINE          	VARCHAR2(2 CHAR),
		  FILE_NAME_ORG        	VARCHAR2(200 CHAR),
		  FILE_SIZE			   	NUMBER,
		  LUCENE_KEY		   	VARCHAR2(2000 CHAR),
		  SHARED			   	VARCHAR2(2 CHAR) DEFAULT 'F',
		  LINK_KIND			   	VARCHAR2(20 CHAR),
		  LINK_PATH_URL		   	VARCHAR2(2000 CHAR),
		  FILE_META				CLOB,
		  HOST_ID				NUMBER,
		  PATH_TO_ASSET		    VARCHAR2(100 CHAR),
		   CLOUD_URL			VARCHAR2(500 CHAR),
		  CLOUD_URL_ORG		   VARCHAR2(500 CHAR),
		  HASHTAG			   VARCHAR2(100 CHAR),
		  IS_AVAILABLE			VARCHAR2(1) DEFAULT 0,
		  CLOUD_URL_EXP		   NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#FILE_PK PRIMARY KEY (FILE_ID),
		CONSTRAINT #arguments.thestruct.host_db_prefix#FILES_HOSTS_FK1 FOREIGN KEY (HOST_ID) REFERENCES HOSTS (HOST_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- FILES DESC --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#files_desc
		(
		  ID			 NUMBER NOT NULL,
		  FILE_ID_R      NUMBER,
		  LANG_ID_R      NUMBER,
		  FILE_DESC      CLOB,
		  FILE_KEYWORDS  CLOB,
		  HOST_ID		 NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#FILE_DESC_FK_FILE FOREIGN KEY (FILE_ID_R)
	REFERENCES #arguments.thestruct.host_db_prefix#FILES (FILE_ID)
	ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- IMAGES --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#images
		(
		  IMG_ID              NUMBER,
		  METABLOB        	  VARCHAR2(2 CHAR),
		  METAEXIF            VARCHAR2(2 CHAR),
		  METAIPTC            VARCHAR2(2 CHAR),
		  METAXMP             VARCHAR2(2 CHAR),
		  IMAGE               VARCHAR2(2 CHAR),
		  THUMB               VARCHAR2(2 CHAR),
		  COMP                VARCHAR2(2 CHAR),
		  COMP_UW             VARCHAR2(2 CHAR),
		  IMG_GROUP           NUMBER DEFAULT NULL,
		  IMG_PUBLISHER       VARCHAR2(200 CHAR),
		  IMG_FILENAME        VARCHAR2(200 CHAR),
		  FOLDER_ID_R         NUMBER DEFAULT NULL,
		  IMG_CUSTOM_ID       VARCHAR2(100 CHAR),
		  IMG_ONLINE          VARCHAR2(2 CHAR),
		  IMG_OWNER           NUMBER,
		  IMG_CREATE_DATE     DATE,
		  IMG_CREATE_TIME     TIMESTAMP,
		  IMG_CHANGE_DATE     DATE,
		  IMG_CHANGE_TIME     TIMESTAMP,
		  IMG_RANKING         NUMBER,
		  IMG_SINGLE_SALE     VARCHAR2(2 CHAR),
		  IMG_IS_NEW          VARCHAR2(2 CHAR),
		  IMG_SELECTION       VARCHAR2(2 CHAR),
		  IMG_IN_PROGRESS     VARCHAR2(2 CHAR),
		  IMG_ALIGNMENT       VARCHAR2(200 CHAR),
		  IMG_LICENSE         VARCHAR2(200 CHAR),
		  IMG_DOMINANT_COLOR  VARCHAR2(200 CHAR),
		  IMG_COLOR_MODE      VARCHAR2(200 CHAR),
		  IMG_IMAGE_TYPE      VARCHAR2(200 CHAR),
		  IMG_CATEGORY_ONE    CLOB,
		  IMG_REMARKS         CLOB,
		  IMG_EXTENSION       VARCHAR2(6 CHAR),
		  THUMB_EXTENSION	  VARCHAR2(6 CHAR),
		  THUMB_WIDTH         NUMBER,
		  THUMB_HEIGHT        NUMBER,
		  IMG_FILENAME_ORG    VARCHAR2(200 CHAR),
		  IMG_WIDTH           NUMBER,
  		  IMG_HEIGHT          NUMBER,
	 	  IMG_SIZE            NUMBER,
  		  THUMB_SIZE          NUMBER,
		  LUCENE_KEY		  VARCHAR2(2000 CHAR),
		  SHARED			  VARCHAR2(2 CHAR) DEFAULT 'F',
		  LINK_KIND			  VARCHAR2(20 CHAR),
		  LINK_PATH_URL		  VARCHAR2(2000 CHAR),
		  IMG_META			  CLOB,
		  HOST_ID			  NUMBER,
		  PATH_TO_ASSET		  VARCHAR2(100 CHAR),
		  CLOUD_URL			VARCHAR2(500 CHAR),
		  CLOUD_URL_ORG		   VARCHAR2(500 CHAR),
		  HASHTAG			   VARCHAR2(100 CHAR),
		  IS_AVAILABLE			VARCHAR2(1) DEFAULT 0,
		  CLOUD_URL_EXP		   NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#IMAGE_PK PRIMARY KEY (IMG_ID),
		CONSTRAINT #arguments.thestruct.host_db_prefix#IMAGE_HOSTS_FK1 FOREIGN KEY (HOST_ID) REFERENCES HOSTS (HOST_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- IMAGES CLOB --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#images_text
		(
		  ID			   NUMBER NOT NULL,
		  IMG_ID_R         NUMBER NOT NULL,
		  LANG_ID_R        NUMBER NOT NULL,
		  IMG_KEYWORDS     CLOB,
		  IMG_DESCRIPTION  CLOB,
		  HOST_ID		 NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#IMAGE_TEXT_FK_IMG FOREIGN KEY (IMG_ID_R)
	REFERENCES #arguments.thestruct.host_db_prefix#IMAGES (IMG_ID)
	ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- LOG ASSETS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#log_assets
		(
		  LOG_ID			NUMBER NOT NULL, 
		  LOG_USER			NUMBER, 
		  LOG_ACTION		VARCHAR2(100 CHAR), 
		  LOG_DATE			DATE, 
		  LOG_TIME			TIMESTAMP, 
		  LOG_DESC			VARCHAR2(500 CHAR), 
		  LOG_FILE_TYPE		VARCHAR2(5 CHAR), 
		  LOG_BROWSER		VARCHAR2(500 CHAR), 
		  LOG_IP			VARCHAR2(200 CHAR), 
		  LOG_TIMESTAMP		TIMESTAMP, 
		  HOST_ID			NUMBER,
		  CONSTRAINT #arguments.thestruct.host_db_prefix#LOG_ASSETS_PK PRIMARY KEY (LOG_ID)
		)
		
		</cfquery>
		
		<!--- LOG FOLDERS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#log_folders
		(
		  LOG_ID			NUMBER NOT NULL, 
		  LOG_USER			NUMBER, 
		  LOG_ACTION		VARCHAR2(100 CHAR), 
		  LOG_DATE			DATE, 
		  LOG_TIME			TIMESTAMP, 
		  LOG_DESC			VARCHAR2(500 CHAR), 
		  LOG_BROWSER		VARCHAR2(500 CHAR), 
		  LOG_IP			VARCHAR2(200 CHAR), 
		  LOG_TIMESTAMP		TIMESTAMP, 
		  HOST_ID			NUMBER,
		  CONSTRAINT #arguments.thestruct.host_db_prefix#LOG_FOLDERS_PK PRIMARY KEY (LOG_ID)
		)
		
		</cfquery>
		
		<!--- LOG USERS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#log_users
		(
		  LOG_ID			NUMBER NOT NULL, 
		  LOG_USER			NUMBER, 
		  LOG_ACTION		VARCHAR2(100 CHAR), 
		  LOG_DATE			DATE, 
		  LOG_TIME			TIMESTAMP, 
		  LOG_DESC			VARCHAR2(500 CHAR), 
		  LOG_BROWSER		VARCHAR2(500 CHAR), 
		  LOG_IP			VARCHAR2(200 CHAR), 
		  LOG_TIMESTAMP		TIMESTAMP,
		  LOG_SECTION		VARCHAR2(10 CHAR),
		  HOST_ID			NUMBER,
		  CONSTRAINT #arguments.thestruct.host_db_prefix#LOG_USERS_PK PRIMARY KEY (LOG_ID)
		)
		
		</cfquery>
		
		<!--- LOG SEARCH --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#log_search
		(
		  LOG_ID          	NUMBER NOT NULL,
		  LOG_USER        	NUMBER,
		  LOG_DATE        	DATE,
		  LOG_TIME        	TIMESTAMP,
		  LOG_SEARCH_FOR  	VARCHAR2(500 CHAR),
		  LOG_FOUNDITEMS  	NUMBER,
		  LOG_SEARCH_FROM 	VARCHAR2(50 CHAR),
		  LOG_TIMESTAMP   	TIMESTAMP,
		  LOG_BROWSER     	VARCHAR2(500 CHAR), 
		  LOG_IP 		  	VARCHAR2(200 CHAR), 
		  HOST_ID			NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#LOG_SEARCH_PK PRIMARY KEY (LOG_ID)
		)
		
		</cfquery>
		
		<!--- SETTINGS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#settings
		(
		  SET_ID    VARCHAR2(100 CHAR) NOT NULL,
		  SET_PREF  CLOB,
		  HOST_ID	NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#SETTINGS_HOSTS_FK1 FOREIGN KEY (HOST_ID) REFERENCES HOSTS (HOST_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- SETTINGS 2 --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#settings_2
		(
		  SET2_ID                       NUMBER NOT NULL,
		  SET2_DATE_FORMAT              VARCHAR2(20 CHAR),
		  SET2_DATE_FORMAT_DEL          VARCHAR2(3 CHAR),
		  SET2_META_KEYWORDS            CLOB,
		  SET2_META_DESC                CLOB,
		  SET2_META_AUTHOR              VARCHAR2(200 CHAR),
		  SET2_META_PUBLISHER           VARCHAR2(200 CHAR),
		  SET2_META_COPYRIGHT           VARCHAR2(200 CHAR),
		  SET2_META_ROBOTS              VARCHAR2(200 CHAR),
		  SET2_META_REVISIT             VARCHAR2(200 CHAR),
		  SET2_META_CUSTOM              CLOB,
		  SET2_URL_SP_ORIGINAL          VARCHAR2(2 CHAR),
		  SET2_URL_SP_THUMB             VARCHAR2(2 CHAR),
		  SET2_URL_SP_COMP              VARCHAR2(2 CHAR),
		  SET2_URL_SP_COMP_UW           VARCHAR2(2 CHAR),
		  SET2_INTRANET_LOGO            VARCHAR2(2 CHAR),
		  SET2_URL_APP_SERVER           VARCHAR2(2 CHAR),
		  SET2_ORA_PATH_INTERNAL        VARCHAR2(2 CHAR),
		  SET2_CREATE_IMGFOLDERS_WHERE  NUMBER,
		  SET2_IMG_FORMAT               VARCHAR2(4 CHAR),
		  SET2_IMG_THUMB_WIDTH          NUMBER,
		  SET2_IMG_THUMB_HEIGTH         NUMBER,
		  SET2_IMG_COMP_WIDTH           NUMBER,
		  SET2_IMG_COMP_HEIGTH          NUMBER,
		  SET2_IMG_DOWNLOAD_ORG         VARCHAR2(2 CHAR),
		  SET2_DOC_DOWNLOAD             VARCHAR2(2 CHAR),
		  SET2_INTRANET_REG_EMAILS      VARCHAR2(2 CHAR),
		  SET2_INTRANET_REG_EMAILS_SUB  VARCHAR2(2 CHAR),
		  SET2_INTRANET_GEN_DOWNLOAD    VARCHAR2(2 CHAR),
		  SET2_CAT_WEB                  VARCHAR2(2 CHAR),
		  SET2_CAT_INTRA                VARCHAR2(2 CHAR),
		  SET2_URL_WEBSITE              VARCHAR2(200 CHAR),
		  SET2_PAYMENT_PRE              VARCHAR2(2 CHAR),
		  SET2_PAYMENT_BILL             VARCHAR2(2 CHAR),
		  SET2_PAYMENT_POD              VARCHAR2(2 CHAR),
		  SET2_PAYMENT_CC               VARCHAR2(2 CHAR),
		  SET2_PAYMENT_CC_CARDS         VARCHAR2(500 CHAR),
		  SET2_PAYMENT_PAYPAL           VARCHAR2(2 CHAR),
		  SET2_PATH_IMAGEMAGICK         VARCHAR2(200 CHAR),
		  SET2_EMAIL_SERVER             VARCHAR2(200 CHAR),
		  SET2_EMAIL_FROM               VARCHAR2(200 CHAR),
		  SET2_EMAIL_SMTP_USER          VARCHAR2(200 CHAR),
		  SET2_EMAIL_SMTP_PASSWORD      VARCHAR2(200 CHAR),
		  SET2_EMAIL_SERVER_PORT        NUMBER,
		  SET2_ORA_PATH_INCOMING		VARCHAR2(2 CHAR),
		  SET2_ORA_PATH_INCOMING_BATCH	VARCHAR2(2 CHAR),
		  SET2_ORA_PATH_OUTGOING		VARCHAR2(2 CHAR),
		  SET2_VID_PREVIEW_HEIGTH		NUMBER,
		  SET2_VID_PREVIEW_WIDTH		NUMBER,
		  SET2_PATH_FFMPEG				VARCHAR2(200 CHAR),
		  SET2_VID_PREVIEW_TIME			VARCHAR2(10 CHAR),
		  SET2_VID_PREVIEW_START		VARCHAR2(10 CHAR),
		  SET2_URL_SP_VIDEO				VARCHAR2(2 CHAR),
		  SET2_URL_SP_VIDEO_PREVIEW		VARCHAR2(2 CHAR),
		  SET2_VID_PREVIEW_AUTHOR		VARCHAR2(200 CHAR),
		  SET2_VID_PREVIEW_COPYRIGHT	VARCHAR2(200 CHAR),
		  SET2_CAT_VID_WEB				VARCHAR2(2 CHAR),
		  SET2_CAT_VID_INTRA			VARCHAR2(2 CHAR),
		  SET2_CAT_AUD_WEB				VARCHAR2(2 CHAR),
		  SET2_CAT_AUD_INTRA			VARCHAR2(2 CHAR),
		  SET2_CREATE_VIDFOLDERS_WHERE	NUMBER,
		  SET2_PATH_TO_ASSETS			VARCHAR2(300 CHAR),
		  SET2_PATH_TO_EXIFTOOL         VARCHAR2(300 CHAR),
		  SET2_NIRVANIX_NAME			VARCHAR2(500 CHAR),
		  SET2_NIRVANIX_PASS			VARCHAR2(500 CHAR),
		  HOST_ID						NUMBER,
		  SET2_AWS_BUCKET				VARCHAR2(100 CHAR),
		CONSTRAINT #arguments.thestruct.host_db_prefix#SETTINGS2_HOSTS_FK1 FOREIGN KEY (HOST_ID) REFERENCES HOSTS (HOST_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- KEYWORDS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#img_keywords
		(
		  KEY_ID     NUMBER NOT NULL,
		  KEY_LEVEL  NUMBER,
		  KEY_ID_R   NUMBER,
		  HOST_ID		 NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#IMG_KEYWORDS_PK PRIMARY KEY (KEY_ID),
CONSTRAINT #arguments.thestruct.host_db_prefix#IMG_KEYWORDS_FK1 FOREIGN KEY (KEY_ID_R)
	  REFERENCES #arguments.thestruct.host_db_prefix#IMG_KEYWORDS (KEY_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- KEYWORDS CLOB --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#img_keywords_text
		(
		  KEY_ID_R   NUMBER,
		  LANG_ID_R  NUMBER,
		  KEY_TEXT   CLOB,
		  HOST_ID		 NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#IMG_KEYWORDS_TEXT_FK1 FOREIGN KEY (KEY_ID_R)
	REFERENCES #arguments.thestruct.host_db_prefix#IMG_KEYWORDS (KEY_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- TEMP --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#temp
		(
		  TMP_TOKEN     VARCHAR2(100 CHAR),
		  TMP_FILENAME  CLOB,
		  HOST_ID		NUMBER
		)
		
		</cfquery>
		
		<!--- COLLECTIONS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#collections
		(
		  COL_ID        	NUMBER NOT NULL,
		  FOLDER_ID_R   	NUMBER DEFAULT NULL,
		  COL_OWNER     	NUMBER,
		  CREATE_DATE   	DATE,
		  CREATE_TIME   	TIMESTAMP,
		  CHANGE_DATE   	DATE,
		  CHANGE_TIME   	TIMESTAMP,
		  COL_TEMPLATE  	VARCHAR2(100 CHAR),
		  COL_SHARED		VARCHAR2(2 CHAR) DEFAULT 'F',
		  COL_NAME_SHARED	VARCHAR2(200 CHAR),
		  share_dl_org		varchar2(1 char) DEFAULT 'f',
     	  share_comments	varchar2(1 char) DEFAULT 'f',
		  share_upload		varchar2(1 char) DEFAULT 'f',
		  share_order		varchar2(1 char) DEFAULT 'f',
		  share_order_user	number,
		  HOST_ID			NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#COLLECTIONS_PK PRIMARY KEY (COL_ID),
		CONSTRAINT #arguments.thestruct.host_db_prefix#COLLECTIONS_HOSTS_FK1 FOREIGN KEY (HOST_ID) REFERENCES HOSTS (HOST_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- COLLECTIONS CLOB --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#collections_text
		(
		  COL_ID_R      NUMBER,
		  LANG_ID_R     NUMBER,
		  COL_DESC      CLOB,
		  COL_KEYWORDS  CLOB,
		  COL_NAME      VARCHAR2(200 CHAR),
		  HOST_ID		 NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#COLLECTIONS_TEXT_#arguments.thestruct.host_db_prefix#FK1 FOREIGN KEY (COL_ID_R)
	REFERENCES #arguments.thestruct.host_db_prefix#COLLECTIONS (COL_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- COLLECTIONS FILES CROSS TABLE --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#collections_ct_files
		(
		  COL_ID_R       	NUMBER,
		  FILE_ID_R      	NUMBER,
		  COL_FILE_TYPE  	VARCHAR2(5 CHAR),
		  COL_ITEM_ORDER  	NUMBER,
		  COL_FILE_FORMAT  	VARCHAR2(20 CHAR),
		  HOST_ID		 NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#COLLECTIONS_CT_FILES_FK1 FOREIGN KEY (COL_ID_R)
	REFERENCES #arguments.thestruct.host_db_prefix#COLLECTIONS (COL_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- COLLECTIONS GROUPS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#collections_groups
		(
		  COL_ID_R       	NUMBER,
		  GRP_ID_R			NUMBER,
		  GRP_PERMISSION	VARCHAR2(2 CHAR),
		  HOST_ID		 NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#COLLECTIONS_GROUPS_FK1 FOREIGN KEY (COL_ID_R)
	  REFERENCES #arguments.thestruct.host_db_prefix#COLLECTIONS (COL_ID) ON DELETE SET NULL ENABLE
		)
		
		</cfquery>
		
		<!--- USER FAVORITES --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#users_favorites
		(
		  USER_ID_R  	NUMBER,
		  FAV_TYPE   	VARCHAR2(8 CHAR),
		  FAV_ID     	NUMBER,
		  FAV_KIND   	VARCHAR2(8 CHAR),
		  FAV_ORDER  	NUMBER,
		  HOST_ID		NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#USERS_FAVORITES_FK1 FOREIGN KEY (USER_ID_R)
	  REFERENCES USERS (USER_ID) ON DELETE SET NULL ENABLE
		)
		
		</cfquery>
		
		<!--- VIDEOS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#videos
		(
		VID_ID					NUMBER,
		VID_FILENAME			VARCHAR2(200 CHAR),
		FOLDER_ID_R				NUMBER,
		VID_CUSTOM_ID			VARCHAR2(100 CHAR),
		VID_ONLINE				VARCHAR2(2 CHAR),
		VID_OWNER				NUMBER,
		VID_CREATE_DATE			DATE,
		VID_CREATE_TIME			TIMESTAMP,
		VID_CHANGE_DATE			DATE,
		VID_CHANGE_TIME			TIMESTAMP,
		VID_RANKING				NUMBER,
		VID_SINGLE_SALE			VARCHAR2(2 CHAR),
		VID_IS_NEW				VARCHAR2(2 CHAR),
		VID_SELECTION			VARCHAR2(2 CHAR),
		VID_IN_PROGRESS			VARCHAR2(2 CHAR),
		VID_LICENSE				VARCHAR2(200 CHAR),
		VID_CATEGORY_ONE		CLOB,
		VID_REMARKS				CLOB,
		VID_WIDTH				NUMBER,
		VID_HEIGHT				NUMBER,
		VID_FRAMERESOLUTION		NUMBER,
		VID_FRAMERATE			NUMBER,
		VID_VIDEODURATION		NUMBER,
		VID_COMPRESSIONTYPE		CLOB,
		VID_BITRATE				NUMBER,
		VID_EXTENSION			VARCHAR2(10 CHAR),
		VID_MIMETYPE			CLOB,
		VID_PREVIEW_WIDTH		NUMBER,
		VID_PREVIEW_HEIGTH		NUMBER,
		VID_GROUP				NUMBER DEFAULT NULL,
		VID_PUBLISHER			VARCHAR2(200 CHAR),
		VID_NAME_ORG			VARCHAR2(200 CHAR),
		VID_NAME_IMAGE			VARCHAR2(200 CHAR),
		VID_NAME_PRE			VARCHAR2(200 CHAR),
		VID_NAME_PRE_IMG		VARCHAR2(200 CHAR),
	 	VID_SIZE                NUMBER,
	 	VID_PREV_SIZE           NUMBER,
	 	LUCENE_KEY		   		VARCHAR2(2000 CHAR),
	 	SHARED			  		VARCHAR2(2 CHAR) DEFAULT 'F',
	 	LINK_KIND			    VARCHAR2(20 CHAR),
		LINK_PATH_URL		    VARCHAR2(2000 CHAR),
		VID_META				CLOB,
		HOST_ID					NUMBER,
		PATH_TO_ASSET		    VARCHAR2(100 CHAR),
		CLOUD_URL			VARCHAR2(500 CHAR),
		  CLOUD_URL_ORG		   VARCHAR2(500 CHAR),
		  HASHTAG			   VARCHAR2(100 CHAR),
		  IS_AVAILABLE			VARCHAR2(1) DEFAULT 0,
		  CLOUD_URL_EXP		   NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#VIDEO_PK PRIMARY KEY (VID_ID),
		CONSTRAINT #arguments.thestruct.host_db_prefix#VIDEO_HOSTS_FK1 FOREIGN KEY (HOST_ID) REFERENCES HOSTS (HOST_ID) ON DELETE CASCADE ENABLE
		)
		</cfquery>
		
		<!--- VIDEOS CLOB --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#videos_text
		(
		  ID			   NUMBER NOT NULL,
		  VID_ID_R         NUMBER NOT NULL,
		  LANG_ID_R        NUMBER NOT NULL,
		  VID_KEYWORDS     CLOB,
		  VID_DESCRIPTION  CLOB,
		  VID_TITLE		   CLOB,
		  HOST_ID		 NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#VIDEO_TEXT_FK_VID FOREIGN KEY (VID_ID_R)
		REFERENCES #arguments.thestruct.host_db_prefix#VIDEOS (VID_ID) ON DELETE CASCADE ENABLE
		)
		</cfquery>

		<!--- SCHEDULES --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#schedules
		(
			SCHED_ID 			 NUMBER NOT NULL,
			SET2_ID_R 			 NUMBER,
			SCHED_USER 			 NUMBER,
			SCHED_STATUS 		 VARCHAR2(1 CHAR) DEFAULT 1,
			SCHED_METHOD 		 VARCHAR2(10 CHAR),
			SCHED_NAME 			 VARCHAR2(255 CHAR),
			SCHED_FOLDER_ID_R    NUMBER,
			SCHED_ZIP_EXTRACT 	 NUMBER,
			SCHED_SERVER_FOLDER  CLOB,
			SCHED_SERVER_RECURSE NUMBER DEFAULT 1,
			SCHED_SERVER_FILES   NUMBER DEFAULT 0,
			SCHED_MAIL_POP 		 VARCHAR2(255 CHAR),
			SCHED_MAIL_USER 	 VARCHAR2(255 CHAR),
			SCHED_MAIL_PASS 	 VARCHAR2(255 CHAR),
			SCHED_MAIL_SUBJECT 	 VARCHAR2(255 CHAR),
			SCHED_FTP_SERVER 	 VARCHAR2(255 CHAR),
			SCHED_FTP_USER 		 VARCHAR2(255 CHAR),
			SCHED_FTP_PASS 		 VARCHAR2(255 CHAR),
			SCHED_FTP_PASSIVE    NUMBER DEFAULT 0,
			SCHED_FTP_FOLDER 	 VARCHAR2(255 CHAR),
			SCHED_INTERVAL       VARCHAR2(255 CHAR),
			SCHED_START_DATE     DATE,
			SCHED_START_TIME     TIMESTAMP,
			SCHED_END_DATE       DATE,
			SCHED_END_TIME       TIMESTAMP,
			HOST_ID				 NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#SCHEDULES_PK PRIMARY KEY (SCHED_ID),
		CONSTRAINT #arguments.thestruct.host_db_prefix#SCHEDULES_FK2 FOREIGN KEY (SCHED_USER)
		REFERENCES USERS (USER_ID) ON DELETE SET NULL ENABLE,
		CONSTRAINT #arguments.thestruct.host_db_prefix#SCHEDULES_HOSTS_FK3 FOREIGN KEY (HOST_ID) 
		REFERENCES HOSTS (HOST_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- SCHEDULES_LOG --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		 CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#schedules_log
		(
			SCHED_LOG_ID        NUMBER NOT NULL,
			SCHED_ID_R          NUMBER,
			SCHED_LOG_USER      NUMBER,
			SCHED_LOG_ACTION    VARCHAR2(10 CHAR),
			SCHED_LOG_DATE      DATE,
			SCHED_LOG_TIME      TIMESTAMP,
			SCHED_LOG_DESC      CLOB,
			HOST_ID		 NUMBER,
		CONSTRAINT #arguments.thestruct.host_db_prefix#SCHEDULES_LOG_PK PRIMARY KEY (SCHED_LOG_ID),
CONSTRAINT #arguments.thestruct.host_db_prefix#SCHEDULES_LOG_FK1 FOREIGN KEY (SCHED_ID_R)
	REFERENCES #arguments.thestruct.host_db_prefix#SCHEDULES (SCHED_ID) ON DELETE CASCADE ENABLE
		)
		
		</cfquery>
		
		<!--- CUSTOM FIELDS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#custom_fields
		(
			cf_id 			NUMBER, 
			cf_type	 		VARCHAR2(20 CHAR), 
			cf_order 		NUMBER, 
			cf_enabled 		VARCHAR2(2 CHAR), 
			cf_show			VARCHAR2(10 CHAR),
			cf_group 		VARCHAR2(100 CHAR),
			HOST_ID			NUMBER,
			CONSTRAINT #arguments.thestruct.host_db_prefix#CUSTOM_FIELDS_PK PRIMARY KEY (CF_ID)
		)
		
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#custom_fields_text
		(
			cf_id_r			NUMBER, 
			lang_id_r 		NUMBER, 
			cf_text			CLOB,
			HOST_ID		 NUMBER,
			CONSTRAINT #arguments.thestruct.host_db_prefix#cf_text FOREIGN KEY (cf_id_r) REFERENCES #arguments.thestruct.host_db_prefix#custom_fields (cf_id) ON DELETE CASCADE
		)
		
		</cfquery>
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#custom_fields_values
		(
			cf_id_r			NUMBER, 
			asset_id_r 		NUMBER, 
			cf_value		CLOB,
			HOST_ID		 NUMBER,
			CONSTRAINT #arguments.thestruct.host_db_prefix#cf_values FOREIGN KEY (cf_id_r) REFERENCES #arguments.thestruct.host_db_prefix#custom_fields (cf_id) ON DELETE CASCADE
		)
		
		</cfquery>
		
		<!--- COMMENTS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#comments
		(
			COM_ID			VARCHAR2(100 CHAR),
			ASSET_ID_R		NUMBER,
			ASSET_TYPE		VARCHAR2(10 CHAR),
			USER_ID_R		NUMBER,
			COM_TEXT		CLOB,
			COM_DATE		TIMESTAMP,
			HOST_ID		 NUMBER,
			CONSTRAINT #arguments.thestruct.host_db_prefix#COMMENTS_PK PRIMARY KEY (COM_ID)
		)
		
		</cfquery>
		
		<!--- Versions --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#versions
		(
			asset_id_r			NUMBER,
			ver_version			NUMBER DEFAULT NULL,
			ver_type			VARCHAR2(5 CHAR),
			ver_date_add		TIMESTAMP,
			ver_who				NUMBER,
			ver_filename_org 	VARCHAR2(200 CHAR),
			ver_extension	 	VARCHAR2(7 CHAR),
			thumb_width			NUMBER,
			thumb_height		NUMBER,
			img_width			NUMBER,
			img_height			NUMBER,
			img_size			NUMBER,
			thumb_size			NUMBER,
			vid_size			NUMBER,
			vid_width			NUMBER,
			vid_height			NUMBER,
			vid_name_image		VARCHAR2(200 CHAR),
			HOST_ID		 		NUMBER,
			cloud_url_org		VARCHAR(500 CHAR),
			ver_thumbnail		VARCHAR(200 CHAR)
		)
		</cfquery>
		
		<!--- Translations --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#languages
		(
			lang_id				NUMBER NOT NULL,
			lang_name			VARCHAR2(100 CHAR) NOT NULL,
			lang_active			VARCHAR2(2 CHAR) default 'f',
			HOST_ID				NUMBER
		)
		</cfquery>
		
		<!--- AUDIOS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#audios
		(
			aud_ID              NUMBER,
			FOLDER_ID_R         NUMBER,
			aud_CREATE_DATE     DATE,
			aud_CREATE_TIME     TIMESTAMP,
			aud_CHANGE_DATE     DATE,
			aud_CHANGE_TIME     TIMESTAMP,
			aud_OWNER           NUMBER,
			aud_TYPE            VARCHAR2(5 CHAR),
			aud_NAME            VARCHAR2(200 CHAR),
			aud_EXTENSION       VARCHAR2(6 CHAR),
			aud_NAME_NOEXT      VARCHAR2(200 CHAR),
			aud_CONTENTTYPE     VARCHAR2(100 CHAR),
			aud_CONTENTSUBTYPE  VARCHAR2(100 CHAR),
			aud_ONLINE          VARCHAR2(2 CHAR),
			aud_NAME_ORG        VARCHAR2(200 CHAR),
			aud_GROUP           NUMBER DEFAULT NULL,
			aud_size			NUMBER,
			LUCENE_KEY		   	VARCHAR2(2000 CHAR),
			SHARED			   	VARCHAR2(2 CHAR) DEFAULT 'F',
			aud_meta			CLOB,
			LINK_KIND			VARCHAR2(20 CHAR),
		  	LINK_PATH_URL		VARCHAR2(2000 CHAR),
		  	HOST_ID				NUMBER,
		  	PATH_TO_ASSET		VARCHAR2(100 CHAR),
		  	CLOUD_URL			VARCHAR2(500 CHAR),
		  	CLOUD_URL_2		   VARCHAR2(500 CHAR),
		  CLOUD_URL_ORG		   VARCHAR2(500 CHAR),
		  HASHTAG			   VARCHAR2(100 CHAR),
		  IS_AVAILABLE			VARCHAR2(1) DEFAULT 0,
		  CLOUD_URL_EXP		   NUMBER,
			CONSTRAINT #arguments.thestruct.host_db_prefix#audios_PK PRIMARY KEY (aud_ID),
			CONSTRAINT #arguments.thestruct.host_db_prefix#AUDIOS_HOSTS_FK1 FOREIGN KEY (HOST_ID) REFERENCES HOSTS (HOST_ID) ON DELETE CASCADE ENABLE
		)
		</cfquery>
		
		<!--- AUDIOS TEXT --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#audios_text
		(
			ID			   		NUMBER NOT NULL,
			aud_ID_R			NUMBER,
			LANG_ID_R			NUMBER,
			aud_DESCRIPTION     CLOB,
			aud_KEYWORDS		CLOB,
			HOST_ID		 NUMBER,
			CONSTRAINT #arguments.thestruct.host_db_prefix#audios_DESC_FK_FILE FOREIGN KEY (aud_ID_R)
			REFERENCES #arguments.thestruct.host_db_prefix#audios (aud_ID) ON DELETE CASCADE
		)
		</cfquery>
		
		<!--- SHARE OPTIONS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE TABLE #arguments.thestruct.theschema#.#arguments.thestruct.host_db_prefix#share_options
		(
			asset_id_r		NUMBER,
			host_id			NUMBER,
			group_asset_id	NUMBER,
			folder_id_r		NUMBER,
			asset_type		varchar2(6 CHAR),
			asset_format	varchar2(10 CHAR),
			asset_dl		varchar2(1 CHAR) DEFAULT '0',
			asset_order		varchar2(1 CHAR) DEFAULT '0'
		)
		</cfquery>
		
	</cffunction>
	
	<!--- Create Indexes --->
	<cffunction name="create_indexes" access="public" output="false">
		<cfargument name="thestruct" type="Struct">
		<!--- FILES DESC --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE INDEX #arguments.thestruct.host_db_prefix#DOC_DESCRIPTION_IDX ON #arguments.thestruct.host_db_prefix#FILES_DESC
		(FILE_DESC)
		INDEXTYPE IS CTXSYS.CONTEXT
		PARAMETERS ('LEXER razuna_lexer')
		</cfquery>
		<!--- FILES KEYWORDS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE INDEX #arguments.thestruct.host_db_prefix#DOC_KEYWORDS_IDX ON #arguments.thestruct.host_db_prefix#FILES_DESC
		(FILE_KEYWORDS)
		INDEXTYPE IS CTXSYS.CONTEXT
		PARAMETERS ('LEXER razuna_lexer')
		</cfquery>
		<!--- IMAGE DESCRIPTIONS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE INDEX #arguments.thestruct.host_db_prefix#IMG_DESCRIPTION_IDX ON #arguments.thestruct.host_db_prefix#IMAGES_TEXT
		(IMG_DESCRIPTION)
		INDEXTYPE IS CTXSYS.CONTEXT
		PARAMETERS ('LEXER razuna_lexer')
		</cfquery>
		<!--- IMAGE KEYWORDS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE INDEX #arguments.thestruct.host_db_prefix#IMG_KEYWORDS_IDX ON #arguments.thestruct.host_db_prefix#IMAGES_TEXT
		(IMG_KEYWORDS)
		INDEXTYPE IS CTXSYS.CONTEXT
		PARAMETERS ('LEXER razuna_lexer')
		</cfquery>
		<!--- IMAGE XMP --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE INDEX #arguments.thestruct.host_db_prefix#IMG_XMP_IDX ON #arguments.thestruct.host_db_prefix#IMAGES
		(metaxmp)
		INDEXTYPE IS CTXSYS.CONTEXT
		PARAMETERS ('LEXER razuna_lexer')
		</cfquery>
		<!--- VIDEO DESCRIPTIONS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE INDEX #arguments.thestruct.host_db_prefix#VID_DESCRIPTION_IDX ON #arguments.thestruct.host_db_prefix#VIDEOS_TEXT
		(VID_DESCRIPTION)
		INDEXTYPE IS CTXSYS.CONTEXT
		PARAMETERS ('LEXER razuna_lexer')
		</cfquery>
		<!--- VIDEO KEYWORDS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE INDEX #arguments.thestruct.host_db_prefix#VID_KEYWORDS_IDX ON #arguments.thestruct.host_db_prefix#VIDEOS_TEXT
		(VID_KEYWORDS)
		INDEXTYPE IS CTXSYS.CONTEXT
		PARAMETERS ('LEXER razuna_lexer')
		</cfquery>
		<!--- AUDIO DESCRIPTIONS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE INDEX #arguments.thestruct.host_db_prefix#AUD_DESCRIPTION_IDX ON #arguments.thestruct.host_db_prefix#AUDIOS_TEXT
		(AUD_DESCRIPTION)
		INDEXTYPE IS CTXSYS.CONTEXT
		PARAMETERS ('LEXER razuna_lexer')
		</cfquery>
		<!--- AUDIO KEYWORDS --->
		<cfquery datasource="#arguments.thestruct.dsn#">
		CREATE INDEX #arguments.thestruct.host_db_prefix#AUD_KEYWORDS_IDX ON #arguments.thestruct.host_db_prefix#AUDIOS_TEXT
		(AUD_KEYWORDS)
		INDEXTYPE IS CTXSYS.CONTEXT
		PARAMETERS ('LEXER razuna_lexer')
		</cfquery>
		<cfreturn />
	</cffunction>
	
	<!--- Clear database completely --->
	<cffunction name="clearall" access="public" output="false">
		<!---
		<!--- Query Constraints --->
		<cfquery datasource="#session.firsttime.database#" name="qrycon">
		SELECT CONSTRAINT_NAME
		FROM user_constraints
		WHERE owner = 'RAZUNA'
		</cfquery>
		<!--- Loop and drop tables --->
		<cfloop query="qrycon">
			<cfquery datasource="#session.firsttime.database#">
			ALTER TABLE #CONSTRAINT_NAME# DISABLE CONSTRAINT #CONSTRAINT_NAME# CASCADE
			</cfquery>
		</cfloop>
		--->
		<!--- Query tables --->
		<cfquery datasource="#session.firsttime.database#" name="qrytbl">
		SELECT object_name
		FROM user_objects 
		WHERE object_type='TABLE'
		</cfquery>
		<!--- Loop and drop tables --->
		<cfloop query="qrytbl">
			<cfquery datasource="#session.firsttime.database#">
			DROP TABLE #object_name# CASCADE CONSTRAINTS
			</cfquery>
		</cfloop>
		<!--- Query Sequences --->
		<cfquery datasource="#session.firsttime.database#" name="qryseq">
		SELECT sequence_name
		FROM all_sequences
		WHERE sequence_owner = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#ucase(application.razuna.theschema)#">
		</cfquery>
		<!--- Loop over Sequences and remove them --->
		<cfloop query="qryseq">
			<cfquery datasource="#session.firsttime.database#">
			DROP SEQUENCE #sequence_name#
			</cfquery>
		</cfloop>
		<cfreturn />
	</cffunction>
		
</cfcomponent>