<!---
*
* Copyright (C) 2005-2008 Razuna Ltd.
*
* This file is part of Razuna - Enterprise Digital Asset Management.
*
* Razuna is free software: you can redistribute it and/or modify
* it under the terms of the GNU Affero Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Razuna is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Affero Public License for more details.
*
* You should have received a copy of the GNU Affero Public License
* along with Razuna. If not, see <http://www.gnu.org/licenses/>.
*
* You may restribute this Program with a special exception to the terms
* and conditions of version 3.0 of the AGPL as described in Razuna's
* FLOSS exception. You should have received a copy of the FLOSS exception
* along with Razuna. If not, see <http://www.razuna.com/licenses/>.
*
--->
<cfcomponent>

	<!--- Backup to XML --->
	<cffunction name="backupxml" output="true">
		<!--- Param --->
		<cfset arguments.thestruct = structnew()>
		<!--- Feedback --->
		<cfoutput><strong>Starting the Backup</strong><br><br></cfoutput>
		<cfflush>
		<!--- Params --->
		<cfparam name="arguments.thestruct.admin" default="T">
		<!--- Create date --->
		<cfset var thedate = dateformat(now(),"yyyy/mm/dd") & " " & timeformat(now(),"HH:MM tt")>
		<cfset arguments.thestruct.thedatefile = dateformat(now(),"yyyy-mm-dd") & "_" & timeformat(now(),"HH-mm-ss-l") & ".xml">
		<!--- Start the XML file --->
<cfsavecontent variable="thefinalxml"><cfoutput><?xml version="1.0" encoding="UTF-8"?>
<razuna>
	<date>#xmlformat(thedate)#</date>
	<origindb>#application.razuna.thedatabase#</origindb>
</cfoutput>
</cfsavecontent>
		<!--- Write the file --->
		<cffile action="write" file="#GetTempDirectory()#/#arguments.thestruct.thedatefile#" output="#thefinalxml#" mode="775" charset="utf-8">
		<!--- Grab the db prefix from the host table --->
		<cfquery datasource="#application.razuna.datasource#" name="qryhost">
		SELECT host_shard_group
		FROM hosts
		GROUP BY host_shard_group
		</cfquery>
		<!--- Feedback --->
		<cfoutput><strong>Selecting the tables...</strong><br><br></cfoutput>
		<cfflush>
		<!--- Loop over the sharding group prefix --->
		<cfloop query="qryhost">
			<!--- Upper Case DB prefix --->
			<cfset theprefix = ucase(host_shard_group) & "%">
			<!--- Oracle --->
			<cfif application.razuna.thedatabase EQ "oracle">
				<cfif arguments.thestruct.admin EQ "T">
					<!--- Feedback --->
					<cfoutput><strong>Backing up default tables...</strong><br></cfoutput>
					<cfflush>
					<cfquery datasource="#application.razuna.datasource#" name="arguments.thestruct.qry">
					SELECT object_name as thetable
					FROM user_objects 
					WHERE object_type='TABLE'
					AND object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="GROUPS">
					OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="HOSTS">
					OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="USERS">
					OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="LOG_ACTIONS">
					OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="USERS_LOGIN">
					OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="WISDOM">
					OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="USERS_COMMENTS">
					OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="FILE_TYPES">
					OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="WEBSERVICES">
					OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="SEARCH_REINDEXULES">
					ORDER BY object_name
					</cfquery>
					<!--- Write XML --->
					<cfinvoke method="writexml" thestruct="#arguments.thestruct#">
					<!--- Now select CT tables only --->
					<cfquery datasource="#application.razuna.datasource#" name="arguments.thestruct.qry">
					SELECT object_name as thetable
					FROM user_objects 
					WHERE object_type = 'TABLE'
					AND object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="CT_GROUPS_USERS">
					OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="CT_GROUPS_PERMISSIONS">
					OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="CT_USERS_HOSTS">
					OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="CT_USERS_REMOTEUSERS">
					</cfquery>
					<!--- Write XML --->
					<cfinvoke method="writexml" thestruct="#arguments.thestruct#">
					<!--- Feedback --->
					<cfoutput><strong>Default tables are done. Continuing...</strong><br><br></cfoutput>
					<cfflush>
				</cfif>
				<!--- Feedback --->
				<cfoutput><strong>Backing up tables...</strong><br></cfoutput>
				<cfflush>
				<!--- Select all host tables --->
				<cfquery datasource="#application.razuna.datasource#" name="arguments.thestruct.qry">
				SELECT object_name as thetable
				FROM user_objects 
				WHERE object_type = 'TABLE' 
				AND object_name LIKE <cfqueryparam cfsqltype="cf_sql_varchar" value="#theprefix#">
				OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="MODULES">
				OR object_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="PERMISSIONS">
				ORDER BY object_name
				</cfquery>
				<!--- Write XML --->
				<cfinvoke method="writexml" thestruct="#arguments.thestruct#">
				<!--- Feedback --->
				<cfoutput><strong>Backing up tables... done. Continuing...</strong><br></cfoutput>
				<cfflush>
			<!--- DB2 --->
			<cfelseif application.razuna.thedatabase EQ "db2">
				<!--- If from admin select default tables also --->
				<cfif arguments.thestruct.admin EQ "T">
					<!--- Feedback --->
					<cfoutput><strong>Backing up default tables...</strong><br></cfoutput>
					<cfflush>
					<cfquery datasource="#application.razuna.datasource#" name="arguments.thestruct.qry">
					SELECT DISTINCT tabname as thetable
					FROM syscat.tables
					WHERE (tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="GROUPS">
					OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="HOSTS">
					OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="USERS">
					OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="LOG_ACTIONS">
					OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="USERS_LOGIN">
					OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="WISDOM">
					OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="USERS_COMMENTS">
					OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="FILE_TYPES">
					OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="WEBSERVICES">
					OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="SEARCH_REINDEXULES">)
					AND tabschema = <cfqueryparam cfsqltype="cf_sql_varchar" value="#ucase(application.razuna.theschema)#">
					ORDER BY tabname
					</cfquery>
					<!--- Write XML --->
					<cfinvoke method="writexml" thestruct="#arguments.thestruct#">
					<!--- Now select CT tables only --->
					<cfquery datasource="#application.razuna.datasource#" name="arguments.thestruct.qry">
					SELECT tabname as thetable
					FROM syscat.tables
					WHERE (tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="CT_GROUPS_USERS">
					OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="CT_GROUPS_PERMISSIONS">
					OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="CT_USERS_HOSTS">
					OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="CT_USERS_REMOTEUSERS">)
					AND tabschema = <cfqueryparam cfsqltype="cf_sql_varchar" value="#ucase(application.razuna.theschema)#">
					</cfquery>
					<!--- Write XML --->
					<cfinvoke method="writexml" thestruct="#arguments.thestruct#">
					<!--- Feedback --->
					<cfoutput><strong>Default tables are done. Continuing...</strong><br><br></cfoutput>
					<cfflush>
				</cfif>
				<!--- Feedback --->
				<cfoutput><strong>Backing up tables...</strong><br></cfoutput>
				<cfflush>
				<!--- Select all host tables --->
				<cfquery datasource="#application.razuna.datasource#" name="arguments.thestruct.qry">
				SELECT tabname as thetable
				FROM syscat.tables
				WHERE (tabname LIKE <cfqueryparam cfsqltype="cf_sql_varchar" value="#theprefix#">
				OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="MODULES">
				OR tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="PERMISSIONS">)
				AND tabschema = <cfqueryparam cfsqltype="cf_sql_varchar" value="#ucase(application.razuna.theschema)#">
				ORDER BY tabname
				</cfquery>
				<!--- Write XML --->
				<cfinvoke method="writexml" thestruct="#arguments.thestruct#">
				<!--- Feedback --->
				<cfoutput><strong>Backing up tables... done. Continuing...</strong><br></cfoutput>
				<cfflush>
			<!--- All other DBs --->
			<cfelse>
				<!--- If from admin select default tables also --->
				<cfif arguments.thestruct.admin EQ "T">
					<!--- Feedback --->
					<cfoutput><strong>Backing up default tables...</strong><br></cfoutput>
					<cfflush>
					<cfquery datasource="#application.razuna.datasource#" name="arguments.thestruct.qry">
					SELECT DISTINCT table_name as thetable
					FROM information_schema.tables
					WHERE table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="GROUPS">
					OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="HOSTS">
					OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="USERS">
					OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="LOG_ACTIONS">
					OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="USERS_LOGIN">
					OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="WISDOM">
					OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="USERS_COMMENTS">
					OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="FILE_TYPES">
					OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="WEBSERVICES">
					OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="SEARCH_REINDEXULES">
					<!--- Get the Sequences DB also --->
					<cfif application.razuna.thedatabase NEQ "h2">
						OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="SEQUENCES">
					</cfif>
					ORDER BY table_name
					</cfquery>
					<!--- Write XML --->
					<cfinvoke method="writexml" thestruct="#arguments.thestruct#">
					<!--- Now select CT tables only --->
					<cfquery datasource="#application.razuna.datasource#" name="arguments.thestruct.qry">
					SELECT table_name as thetable
					FROM information_schema.tables
					WHERE table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="CT_GROUPS_USERS">
					OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="CT_GROUPS_PERMISSIONS">
					OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="CT_USERS_HOSTS">
					OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="CT_USERS_REMOTEUSERS">
					</cfquery>
					<!--- Write XML --->
					<cfinvoke method="writexml" thestruct="#arguments.thestruct#">
					<!--- Feedback --->
					<cfoutput><strong>Default tables are done. Continuing...</strong><br><br></cfoutput>
					<cfflush>
				</cfif>
				<!--- Feedback --->
				<cfoutput><strong>Backing up tables...</strong><br></cfoutput>
				<cfflush>
				<!--- Select all host tables --->
				<cfquery datasource="#application.razuna.datasource#" name="arguments.thestruct.qry">
				SELECT DISTINCT table_name as thetable
				FROM information_schema.tables
				WHERE table_name LIKE <cfqueryparam cfsqltype="cf_sql_varchar" value="#theprefix#">
				OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="MODULES">
				OR table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="PERMISSIONS">
				ORDER BY table_name
				</cfquery>
				<!--- Write XML --->
				<cfinvoke method="writexml" thestruct="#arguments.thestruct#">
				<!--- Feedback --->
				<cfoutput><strong>Backing up tables... done. Continuing...</strong><br><br></cfoutput>
				<cfflush>
			</cfif>
		</cfloop>
		<!--- Sequences (only needed for admin export) --->
		<cfif arguments.thestruct.admin EQ "T">
			<!--- If on Oracle or H2 we need to read and write the Sequences --->
			<cfif application.razuna.thedatabase EQ "oracle">
				<!--- Query sequences --->
				<cfquery datasource="#application.razuna.datasource#" name="qryt">
				SELECT sequence_name as theseq, last_number as thevalue
				FROM all_sequences
				WHERE sequence_owner = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#ucase(application.razuna.theschema)#">
				</cfquery>
			<cfelseif application.razuna.thedatabase EQ "h2">
				<cfquery datasource="#application.razuna.datasource#" name="qryt">
				SELECT sequence_name as theseq, current_value as thevalue
				FROM information_schema.sequences
				WHERE IS_GENERATED = false
				</cfquery>
			<cfelseif application.razuna.thedatabase EQ "db2">
				<cfquery datasource="#application.razuna.datasource#" name="qryt">
				SELECT seqname as theseq, nextcachefirstvalue as thevalue
				FROM syscat.sequences
				WHERE seqschema = <cfqueryparam cfsqltype="cf_sql_varchar" value="#ucase(application.razuna.theschema)#">
				AND seqtype = <cfqueryparam cfsqltype="cf_sql_varchar" value="S">
				</cfquery>
			</cfif>
<cfif application.razuna.thedatabase EQ "oracle" OR application.razuna.thedatabase EQ "h2" OR application.razuna.thedatabase EQ "db2">
<cfsavecontent variable="thexml"><cfoutput>
	<sequences>
		<cfloop query="qryt"><record id="#currentRow#">
			<col id="sequence_name">#xmlformat(theseq)#</col>
			<col id="current_value">#xmlformat(thevalue)#</col>
		</record>
		</cfloop>
	</sequences>
</cfoutput>
</cfsavecontent>
			<!--- Write the file --->
			<cffile action="append" file="#GetTempDirectory()#/#arguments.thestruct.thedatefile#" output="#thexml#" mode="775" charset="utf-8">
			<cfset thexml = "">
</cfif>
		</cfif>
		<!--- The end of the XML --->
<cfsavecontent variable="theendxml"><cfoutput>
</razuna>
</cfoutput>
</cfsavecontent>
		<!--- Feedback --->
		<cfoutput><strong>We are almost done. Just a few seconds more...</strong><br><br></cfoutput>
		<cfflush>
		<!--- Write the file --->
		<cffile action="append" file="#GetTempDirectory()#/#arguments.thestruct.thedatefile#" output="#theendxml#" mode="775" charset="utf-8">
		<!--- For local --->
		<cfif application.razuna.storage EQ "local">
			<!--- Backup Dir --->
			<cfset var backupdir = ExpandPath("backup")>
			<cfset var backupdl = "#cgi.context_path#/export/backup/#arguments.thestruct.thedatefile#.zip">
			<!--- Download URL complete --->
			<cfset backupdl = "http://#cgi.HTTP_HOST#/" & backupdl>
			<!--- Check if errors folder exists, else create it --->
			<cfif DirectoryExists("#backupdir#") EQ "no">
				<cfdirectory action="create" directory="#backupdir#" mode="775">
			</cfif>
			<!--- Zip it --->
			<cfzip action="create" zipfile="#backupdir#/#arguments.thestruct.thedatefile#.zip" source="#GetTempDirectory()#/#arguments.thestruct.thedatefile#" />
			<!--- And remove original --->
			<cffile action="delete" file="#GetTempDirectory()#/#arguments.thestruct.thedatefile#">
		<!--- For Nirvanix --->
		<cfelseif application.razuna.storage EQ "nirvanix" OR application.razuna.storage EQ "amazon">
			<!--- Outgoing --->
			<cfset var backupdl = "outgoing/#arguments.thestruct.thedatefile#.zip">
			<cfset var backuppath = "#arguments.thestruct.thepath#/#backupdl#">
			<!--- Zip it --->
			<cfzip action="create" zipfile="#backuppath#" source="#GetTempDirectory()#/#arguments.thestruct.thedatefile#" />
			<!--- Download URL complete --->
			<cfset backupdl = "http://#cgi.HTTP_HOST#/#backupdl#">
			<!--- Remove XML file from temp dir --->
			<cffile action="delete" file="#GetTempDirectory()#/#arguments.thestruct.thedatefile#">
		</cfif>
		
		<cfoutput><span style="font-weight:bold;color:green;">Backup successfully done!</span> <a href="#backupdl#">Download the backup file here</a><br><br><a href="##" onclick="window.close();">Click this link to close this window</a>.</cfoutput>
		<!--- Return --->
		<cfreturn />
	</cffunction>

	<!--- Write XML --->
	<cffunction name="writexml" output="true">
		<cfargument name="thestruct" type="struct">
		<!--- Params --->
		<cfset var thecolumns = "">
		<!--- Loop over the qry results --->
		<cfloop query="arguments.thestruct.qry">
			<cfif thetable DOES NOT CONTAIN "temp">
			<!--- Feedback --->
			<cfoutput>Currently running backup of #thetable#<br></cfoutput>
			<cfflush>
			<!--- Get Columns --->
			<cfif application.razuna.thedatabase EQ "db2">
				<cfquery datasource="#application.razuna.datasource#" name="qry_columns">
				SELECT colname as column_name, typename as data_type
				FROM syscat.columns
				WHERE tabname = <cfqueryparam cfsqltype="cf_sql_varchar" value="#thetable#">
				AND colname != 'ADMIN'
				AND colname != 'NAME'
				AND colname != 'REMARKS'
				AND colname != 'ID'
				AND colname != 'IMAGE'
				AND colname != 'THUMB'
				AND colname != 'COMP'
				AND colname != 'COMP_UW'
				AND colname != 'SET2_INTRANET_LOGO'
				AND tabschema = <cfqueryparam cfsqltype="cf_sql_varchar" value="#ucase(application.razuna.theschema)#">
				</cfquery>
			<cfelse>			
				<cfquery datasource="#application.razuna.datasource#" name="qry_columns">
				SELECT column_name, <cfif application.razuna.thedatabase EQ "h2">type_name as data_type<cfelse>data_type</cfif>
				FROM <cfif application.razuna.thedatabase EQ "oracle">all_tab_columns<cfelse>information_schema.columns</cfif>
				WHERE table_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="#thetable#">
				AND column_name != 'ADMIN'
				AND column_name != 'NAME'
				AND column_name != 'REMARKS'
				AND column_name != 'ID'
				AND column_name != 'IMAGE'
				AND column_name != 'THUMB'
				AND column_name != 'COMP'
				AND column_name != 'COMP_UW'
				AND column_name != 'SET2_INTRANET_LOGO'
				</cfquery>
			</cfif>
			<!--- Create our custom list --->
			<cfloop query="qry_columns">
				<cfset thecolumns = thecolumns & column_name & "--" & data_type & ",">
			</cfloop>
			<!--- Query values from table --->
			<cfquery datasource="#application.razuna.datasource#" name="qryt">
			SELECT #valuelist(qry_columns.column_name)#
			FROM #thetable#
			<cfif arguments.thestruct.admin EQ "F">
				<cfif thetable EQ "MODULES">
					WHERE mod_host_id = <cfqueryparam cfsqltype="cf_sql_numeric" value="#session.hostid#">
				<cfelseif thetable EQ "PERMISSIONS">
					WHERE per_host_id = <cfqueryparam cfsqltype="cf_sql_numeric" value="#session.hostid#">
				<cfelse>
					WHERE host_id = <cfqueryparam cfsqltype="cf_sql_numeric" value="#session.hostid#">
				</cfif>
			</cfif>
			</cfquery>
			<!--- Create the XML for this table --->
<cfsavecontent variable="thexml"><cfoutput>
	<table id="#lcase(thetable)#">
		<cfloop query="qryt"><record id="#currentRow#">
		<cfloop list="#thecolumns#" index="i">	<col id="#lcase(listfirst(i,"--"))#" type="#lcase(listlast(i,"--"))#">#xmlformat(evaluate(listfirst(i,"--")))#</col>
		</cfloop></record>
		</cfloop><cfif qryt.recordcount EQ 1><record id="FALSE">
		</record></cfif>
	</table>
</cfoutput>
</cfsavecontent>
			<!--- Write the file --->
			<cffile action="append" file="#GetTempDirectory()#/#arguments.thestruct.thedatefile#" output="#thexml#" mode="775" charset="utf-8">
			<cfset thexml = "">
			<cfset thecolumns = "">
			</cfif>
		</cfloop>
		<!--- Return --->
		<cfreturn />
	</cffunction>
		
</cfcomponent>
